package javagiac;
// -*- compile-command: "javac *.java" -*-
// This example illustrates how giac can be used from Java using SWIG.
// On linux type java runme, on mac os x with giac 32 bits, java -d32 runme

import java.io.*;

public class runme {
  static {
    try {
	System.out.println("Loading giac java interface");
        //System.load("/usr/local/lib/libgiacjava.so");
        System.loadLibrary("javagiac");
    } catch (UnsatisfiedLinkError e) {
      System.err.println("Native code library failed to load. See the chapter on Dynamic Linking Problems in the SWIG Java documentation for help.\n" + e);
      System.exit(1);
    }
  }

  public static void main(String argv[]) 
  {
    context C=new context();
    String s=new String("");
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    gen g=new gen(0);
    while (true){
	System.out.print( "Enter an expression :" );
	try {
	    s = br.readLine();
	} catch (IOException ioe) {
	    System.out.println("I/O error reading expression!");
	    System.exit(1);
	}
	if (s=="")
	    break;
	g=new gen(s,C);
	g=g.eval(1,C);
	System.out.println(g.print(C));
    }
    // gen g=new gen(10,12);
    // gen g=new gen("x**4-1",C);
    System.out.println( "Created gen of type : "+g.getType());
    if (g.getType()==gen_unary_types._SYMB.swigValue()){
	System.out.println( "g operator is "+g.operator_at(0,C).print(C));
	System.out.println( "g has "+giac._size(g,C).getVal()+" arguments");
	System.out.println( "First argument of g is "+g.operator_at(1,C).print(C));
	System.out.println("Creating a giac variable aa with value g, like aa:=g inside Xcas");
	gen a=new gen("aa",C); // create a variable a 
	giac.sto(g,a,C); // like aa:=g
	gen a1=new gen("aa[1]",C); // create a variable to modify a
	giac.sto(new gen(2),a1,C); // like aa[1]:=2; change first arg
	System.out.println("Modifying first argument of aa to 2 like aa[1]:=2 inside Xcas");
	System.out.println("aa now "+a.eval(1,C).print(C));
    }
    //  gen h=giac._factor(g,C);
    gen h=giac._eval(g,C);
    System.out.println( "Value of h: " + h.print(C) );

    h=giac.add(g,g);
    h=giac._simplify(h,C);

    System.out.println( "Value of h: " + h.print(C) );
    // h=new gen(giac.makevecteur(h,new gen(2)),(short)1);
    h=new gen(giac.makevecteur(h,new gen(2),h),(short)gen_comp_subtypes._SEQ__VECT.swigValue());
    System.out.println( "Value of h: " + h.print(C) );

    System.out.println( "Goodbye" );
  }
}
